// functions.cpp V.1.0
// Date: 29/II/2016
/*
Copyright (C) 2016 Casanellas and Fernandez-Sanchez.
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/



#include "declaration.h"
#include <stdlib.h>
#include <stdio.h>
#include <algorithm>
#include <armadillo>
#include <string>
#include <fstream>
#include <iostream>
#include <time.h>
#include <unistd.h>

using namespace std;	
using namespace arma; // for 'armadillo';

int main()

{
	string filename; 
	map <string,string> dna; 

	int i,j,k,q;
	int n_partitions;
	int numb_taxa=4;

	Alignment align; 
	vector <int> power4; 

	map<string, int> tensor; 
	power4=get_species(); 

	cout << "Enter the name of the FASTA file (4 sequences): " << endl; 
	cin >> filename; 

	cout << "Enter the number of partitions in the alignment (3 maximum) : " << endl; 
	cin >> n_partitions; 

	map<string,string>::const_iterator pos;

	align=readFASTA(filename);
	dna=align.seqs; 
	map<string,string> myseqs=align.seqs;
	tensor=Getcolumns(align);
	int length=align.seq_len;	
	string st_length=convertInt(length);

	vector<float> score;
	float aux_01,aux_02,aux_03,sum; 
	float aux_01_inv,aux_02_inv,aux_03_inv; 

	mat flat_01=Flattening(tensor,{0,1},{2,3});
	aux_01=Erik2(flat_01,n_partitions,{0,1},{2,3});
	aux_01_inv=1./aux_01;

	mat flat_02=Flattening(tensor,{0,2},{1,3});
	aux_02=Erik2(flat_02,n_partitions,{0,2},{1,3});
	aux_02_inv=1./aux_02;

	mat flat_03=Flattening(tensor,{0,3},{1,2});
	aux_03=Erik2(flat_03,n_partitions,{0,3},{1,2});
	aux_03_inv=1./aux_03;

	sum=aux_01_inv+aux_02_inv+aux_03_inv;
	string sp0,sp1,sp2,sp3;
	sp0=align.taxa[0];
	sp1=align.taxa[1];
	sp2=align.taxa[2];
	sp3=align.taxa[3];


	cout << "\n" << endl; 
	cout << "Taxa 1: " << sp0 << endl; 
	cout << "Taxa 2: " << sp1 << endl; 
	cout << "Taxa 3: " << sp2 << endl; 
	cout << "Taxa 4: " << sp3 << endl; 
	cout << "\n" << endl; 
  cout << "Topologies : \t" <<  "12|34 \t \t" << " 13|24 \t \t" << " 14|23" << endl; 
	cout << "scores : \t" << aux_01 << "\t " << aux_02 << "\t " <<  aux_03 << endl;
	cout << "weights : \t" << aux_01_inv/sum << "\t " <<  aux_02_inv/sum << "\t " <<  aux_03_inv/sum << endl;  

   return(0);
}




